/*
 * MATLAB Compiler: 4.14 (R2010b)
 * Date: Wed Apr  6 20:19:10 2011
 * Arguments: "-B" "macro_default" "-B" "csharedlib:libphy" "-W" "lib:libphy"
 * "-T" "link:lib" "-v" "modulateFSK.m" "demodulateFSK.m" "modulatePSK.m"
 * "demodulatePSK.m" "chirp.m" "filterSignal.m" "hardlimit.m" 
 */

#include <stdio.h>
#define EXPORTING_libphy 1
#include "libphy.h"

static HMCRINSTANCE _mcr_inst = NULL;


#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
  return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
  int written = 0;
  size_t len = 0;
  len = strlen(s);
  written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
  if (len > 0 && s[ len-1 ] != '\n')
    written += mclWrite(2 /* stderr */, "\n", sizeof(char));
  return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libphy_C_API
#define LIB_libphy_C_API /* No special import/export declaration */
#endif

LIB_libphy_C_API 
bool MW_CALL_CONV libphyInitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler)
{
    int bResult = 0;
  if (_mcr_inst != NULL)
    return true;
  if (!mclmcrInitialize())
    return false;
    {
        mclCtfStream ctfStream = 
            mclGetEmbeddedCtfStream((void *)(libphyInitializeWithHandlers), 
                                    90008);
        if (ctfStream) {
            bResult = mclInitializeComponentInstanceEmbedded(   &_mcr_inst,
                                                                error_handler, 
                                                                print_handler,
                                                                ctfStream, 
                                                                90008);
            mclDestroyStream(ctfStream);
        } else {
            bResult = 0;
        }
    }  
    if (!bResult)
    return false;
  return true;
}

LIB_libphy_C_API 
bool MW_CALL_CONV libphyInitialize(void)
{
  return libphyInitializeWithHandlers(mclDefaultErrorHandler, mclDefaultPrintHandler);
}

LIB_libphy_C_API 
void MW_CALL_CONV libphyTerminate(void)
{
  if (_mcr_inst != NULL)
    mclTerminateInstance(&_mcr_inst);
}

LIB_libphy_C_API 
long MW_CALL_CONV libphyGetMcrID() 
{
  return mclGetID(_mcr_inst);
}

LIB_libphy_C_API 
void MW_CALL_CONV libphyPrintStackTrace(void) 
{
  char** stackTrace;
  int stackDepth = mclGetStackTrace(&stackTrace);
  int i;
  for(i=0; i<stackDepth; i++)
  {
    mclWrite(2 /* stderr */, stackTrace[i], sizeof(char)*strlen(stackTrace[i]));
    mclWrite(2 /* stderr */, "\n", sizeof(char)*strlen("\n"));
  }
  mclFreeStackTrace(&stackTrace, stackDepth);
}


LIB_libphy_C_API 
bool MW_CALL_CONV mlxModulateFSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "modulateFSK", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlxDemodulateFSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "demodulateFSK", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlxModulatePSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "modulatePSK", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlxDemodulatePSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "demodulatePSK", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlxChirp(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "chirp", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlxFilterSignal(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "filterSignal", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlxHardlimit(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "hardlimit", nlhs, plhs, nrhs, prhs);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfModulateFSK(int nargout, mxArray** txFSK, mxArray** numberOfSamples, 
                                 mxArray* byteStream, mxArray* fs, mxArray* fc, mxArray* 
                                 symbolsPerSecond)
{
  return mclMlfFeval(_mcr_inst, "modulateFSK", nargout, 2, 4, txFSK, numberOfSamples, byteStream, fs, fc, symbolsPerSecond);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfDemodulateFSK(int nargout, mxArray** rxFSK, mxArray* packetWaveform, 
                                   mxArray* numberOfBytes, mxArray* fs, mxArray* fc, 
                                   mxArray* symbolsPerSecond, mxArray* receiverType, 
                                   mxArray* useLimiter)
{
  return mclMlfFeval(_mcr_inst, "demodulateFSK", nargout, 1, 7, rxFSK, packetWaveform, numberOfBytes, fs, fc, symbolsPerSecond, receiverType, useLimiter);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfModulatePSK(int nargout, mxArray** txPSK, mxArray** numberOfSamples, 
                                 mxArray* byteStream, mxArray* fs, mxArray* fc, mxArray* 
                                 symbolsPerSecond)
{
  return mclMlfFeval(_mcr_inst, "modulatePSK", nargout, 2, 4, txPSK, numberOfSamples, byteStream, fs, fc, symbolsPerSecond);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfDemodulatePSK(int nargout, mxArray** rxPSK, mxArray* packetWaveform, 
                                   mxArray* numberOfBytes, mxArray* fs, mxArray* fc, 
                                   mxArray* symbolsPerSecond)
{
  return mclMlfFeval(_mcr_inst, "demodulatePSK", nargout, 1, 5, rxPSK, packetWaveform, numberOfBytes, fs, fc, symbolsPerSecond);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfChirp(int nargout, mxArray** y, mxArray** time, mxArray* startFreq, 
                           mxArray* endFreq, mxArray* samplingRate, mxArray* numSeconds, 
                           mxArray* method)
{
  return mclMlfFeval(_mcr_inst, "chirp", nargout, 2, 5, y, time, startFreq, endFreq, samplingRate, numSeconds, method);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfFilterSignal(int nargout, mxArray** y, mxArray* x, mxArray* 
                                  samplingRate, mxArray* freq, mxArray* symbolsPerSecond)
{
  return mclMlfFeval(_mcr_inst, "filterSignal", nargout, 1, 4, y, x, samplingRate, freq, symbolsPerSecond);
}

LIB_libphy_C_API 
bool MW_CALL_CONV mlfHardlimit(int nargout, mxArray** y, mxArray* x)
{
  return mclMlfFeval(_mcr_inst, "hardlimit", nargout, 1, 1, y, x);
}
