//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
//

#ifndef PHY_H_
#define PHY_H_

#include <omnetpp.h>

class Phy : public cSimpleModule {
    public:
        Phy();
        virtual ~Phy();
    protected:
        virtual void initialize();
        virtual void handleMessage(cMessage *msg);
    private:
        const char* modulationType;
        const char* fskReceiverType;
        bool fskUseHardLimiter;
        int samplingRate;
        int carrierFrequency;
        int symbolsPerSecond;
        double signalLevelDB;
};

#endif /* PHY_H_ */
