/*
 * MATLAB Compiler: 4.14 (R2010b)
 * Date: Wed Apr  6 20:18:48 2011
 * Arguments: "-B" "macro_default" "-B" "csharedlib:libchannel" "-W"
 * "lib:libchannel" "-T" "link:lib" "-v" "getAverageSoundVelocity.m"
 * "getNoiseLevelDB.m" "getTransmissionLossDB.m" "simulateChannel.m" "fconv.m" 
 */

#include <stdio.h>
#define EXPORTING_libchannel 1
#include "libchannel.h"

static HMCRINSTANCE _mcr_inst = NULL;


#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
  return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
  int written = 0;
  size_t len = 0;
  len = strlen(s);
  written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
  if (len > 0 && s[ len-1 ] != '\n')
    written += mclWrite(2 /* stderr */, "\n", sizeof(char));
  return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libchannel_C_API
#define LIB_libchannel_C_API /* No special import/export declaration */
#endif

LIB_libchannel_C_API 
bool MW_CALL_CONV libchannelInitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler)
{
    int bResult = 0;
  if (_mcr_inst != NULL)
    return true;
  if (!mclmcrInitialize())
    return false;
    {
        mclCtfStream ctfStream = 
            mclGetEmbeddedCtfStream((void *)(libchannelInitializeWithHandlers), 
                                    1160641);
        if (ctfStream) {
            bResult = mclInitializeComponentInstanceEmbedded(   &_mcr_inst,
                                                                error_handler, 
                                                                print_handler,
                                                                ctfStream, 
                                                                1160641);
            mclDestroyStream(ctfStream);
        } else {
            bResult = 0;
        }
    }  
    if (!bResult)
    return false;
  return true;
}

LIB_libchannel_C_API 
bool MW_CALL_CONV libchannelInitialize(void)
{
  return libchannelInitializeWithHandlers(mclDefaultErrorHandler, mclDefaultPrintHandler);
}

LIB_libchannel_C_API 
void MW_CALL_CONV libchannelTerminate(void)
{
  if (_mcr_inst != NULL)
    mclTerminateInstance(&_mcr_inst);
}

LIB_libchannel_C_API 
long MW_CALL_CONV libchannelGetMcrID() 
{
  return mclGetID(_mcr_inst);
}

LIB_libchannel_C_API 
void MW_CALL_CONV libchannelPrintStackTrace(void) 
{
  char** stackTrace;
  int stackDepth = mclGetStackTrace(&stackTrace);
  int i;
  for(i=0; i<stackDepth; i++)
  {
    mclWrite(2 /* stderr */, stackTrace[i], sizeof(char)*strlen(stackTrace[i]));
    mclWrite(2 /* stderr */, "\n", sizeof(char)*strlen("\n"));
  }
  mclFreeStackTrace(&stackTrace, stackDepth);
}


LIB_libchannel_C_API 
bool MW_CALL_CONV mlxGetAverageSoundVelocity(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                             *prhs[])
{
  return mclFeval(_mcr_inst, "getAverageSoundVelocity", nlhs, plhs, nrhs, prhs);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlxGetNoiseLevelDB(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "getNoiseLevelDB", nlhs, plhs, nrhs, prhs);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlxGetTransmissionLossDB(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                           *prhs[])
{
  return mclFeval(_mcr_inst, "getTransmissionLossDB", nlhs, plhs, nrhs, prhs);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlxSimulateChannel(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "simulateChannel", nlhs, plhs, nrhs, prhs);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlxFconv(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "fconv", nlhs, plhs, nrhs, prhs);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlfGetAverageSoundVelocity(int nargout, mxArray** averageSoundVelocity, 
                                             mxArray* linkDistanceInMeters)
{
  return mclMlfFeval(_mcr_inst, "getAverageSoundVelocity", nargout, 1, 1, averageSoundVelocity, linkDistanceInMeters);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlfGetNoiseLevelDB(int nargout, mxArray** noiseLevelDB, mxArray* 
                                     noiseFile, mxArray* centerFrequencyHz, mxArray* 
                                     symbolsPerSecond, mxArray* modulationType, mxArray* 
                                     useAmbientNoise)
{
  return mclMlfFeval(_mcr_inst, "getNoiseLevelDB", nargout, 1, 5, noiseLevelDB, noiseFile, centerFrequencyHz, symbolsPerSecond, modulationType, useAmbientNoise);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlfGetTransmissionLossDB(int nargout, mxArray** transmissionLossDB, 
                                           mxArray* linkDistanceInMeters)
{
  return mclMlfFeval(_mcr_inst, "getTransmissionLossDB", nargout, 1, 1, transmissionLossDB, linkDistanceInMeters);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlfSimulateChannel(int nargout, mxArray** samples, mxArray** 
                                     numberOfSamples, mxArray* packetWaveform, mxArray* 
                                     impulseResponseFileName, mxArray* snr, mxArray* fs)
{
  return mclMlfFeval(_mcr_inst, "simulateChannel", nargout, 2, 4, samples, numberOfSamples, packetWaveform, impulseResponseFileName, snr, fs);
}

LIB_libchannel_C_API 
bool MW_CALL_CONV mlfFconv(int nargout, mxArray** y, mxArray* x, mxArray* h, mxArray* 
                           normalize)
{
  return mclMlfFeval(_mcr_inst, "fconv", nargout, 1, 3, y, x, h, normalize);
}
